var ds=	Components.classes['@mozilla.org/file/directory_service;1'].
		getService(Components.interfaces.nsIProperties);

function getScriptableStream(is){
	var sis=Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
	sis.init(is);
	return sis;
}

function ClassificationCache(account){
	this.MODE_RDWR= 0x20 | 0x04;
	this.MODE_RDONLY= 0x01;
	this.account=account;
	var file = ds.get('ProfD', Components.interfaces.nsIFile).clone();
	file.append("MailClassifier");
	file.append(account.mozAccount.realUsername + 
		"@" +account.mozAccount.realHostName);
	file.append("classifications.cache");
	this.file=file;
	if(!file.exists()){
		file.create(0,0666);
	}
	this.out = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
	this.inp = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
	
	this.saveClassifications=function(){
		this.out.init(this.file,this.MODE_RDWR, 0666, 0 );
		for(m in this.account.mail){	
			msg=this.account.mail[m];
			if(msg && msg.isClassified()){
				var msguri=m;
				var flduri=msg.getBest().mozillaFolder.URI;
				this.out.write(msguri,msguri.length);
				this.out.write(",",1);
				this.out.write(flduri,flduri.length);
				this.out.write("\n",1);
			}
		}
		this.out.close();

	}	
	this.loadClassifications=function(){
		this.inp.init(this.file,this.MODE_RDONLY,0666,1);
		var inp=getScriptableStream(this.inp);
		while(inp.available()){
			var ch="";
			var mail="";
			var folder="";
			while(ch!=","){
				mail+=ch;
				ch=inp.read(1);
			}
			ch="";
			while(ch!="\n"){
				folder+=ch;
				ch=inp.read(1);
			}
			if(mail && folder && mail.length>0 && folder.length>0){
				this.account.setClassificationFor(mail,folder);
			}
		}
		inp.close();
		this.inp.close();
	}
}
